// BonTuner.h: CBonTuner NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "IBonDriver2.h"
#include "../../Common/PT1SendCtrlCmdUtil.h"
#include "ParseChSet.h"

#define BUFF_SIZE (188*256)

class CBonTuner : public IBonDriver2
{
public:
	CBonTuner();
	virtual ~CBonTuner();

// IBonDriver
	const BOOL OpenTuner(void);
	void CloseTuner(void);

	const BOOL SetChannel(const BYTE bCh);
	const float GetSignalLevel(void);

	const DWORD WaitTsStream(const DWORD dwTimeOut = 0);
	const DWORD GetReadyCount(void);

	const BOOL GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain);
	const BOOL GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain);

	void PurgeTsStream(void);

// IBonDriver2(b)
	LPCTSTR GetTunerName(void);

	const BOOL IsTunerOpening(void);
	
	LPCTSTR EnumTuningSpace(const DWORD dwSpace);
	LPCTSTR EnumChannelName(const DWORD dwSpace, const DWORD dwChannel);

	const BOOL SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	
	const DWORD GetCurSpace(void);
	const DWORD GetCurChannel(void);

	void Release(void);

	static CBonTuner * m_pThis;
	static HINSTANCE m_hModule;

protected:
	CRITICAL_SECTION m_CriticalSection;
	HANDLE m_hOnStreamEvent;

	DWORD m_dwCurSpace;
	DWORD m_dwCurChannel;

	struct TS_BLOCK {
		DWORD dwSetSize;
		BYTE aBuff[TS_BLOCK_SIZE];
		TS_BLOCK(void){
			dwSetSize = 0;
		}
		~TS_BLOCK(void){
		}
		void *operator new(size_t n ) {
			return NEW_DATA_BUFF( n );
		}
		void operator delete(void *p) {
			BYTE *b = (BYTE *)p;
			DELETE_DATA_BUFF( b, sizeof(TS_BLOCK) );
		}
		size_t GetBufferSize() {
			return TS_BLOCK_SIZE;
		}
	};

	queue<TS_BLOCK *> m_TsBuff;
	TS_BLOCK *m_LastBuff;

	HANDLE m_hStopEvent;
	HANDLE m_hThread;

	int m_iID;
	DWORD m_unique;
	int m_iTunerID;
	HANDLE m_phFileMapping;

	BOOL m_bUseUHF;
	BOOL m_bUseCATV;
	BOOL m_bUseVHF;
	BOOL m_bUseBS;
	BOOL m_bUseCS;
	wstring m_strPT1CtrlExe;

	wstring m_strTunerName;

	PipeClient pipeClient;

	CParseChSet m_chSet;	

protected:
	static UINT WINAPI RecvThread(LPVOID pParam);
	int GetPTDeviceInfo(DWORD dwIndex);
};
