#include "StdAfx.h"
#include "memserver.h"
#include <process.h>

using namespace std;

CMemServer::CMemServer(LPCWSTR serverName )
{
	m_pCmdProc = NULL;
	m_pParam = NULL;
	Format( m_serverName, serverName );
	m_hThread = NULL;
	m_hStopEvent = _CreateEvent(FALSE, FALSE, NULL);
	m_hEventConnect = NULL;; //ڑҋ@pCxg
	m_hEventCall = NULL;
	m_hEventReturn = NULL;
	m_hMapping = NULL;
	m_buf = NULL;
}

CMemServer::~CMemServer(void)
{
	Stop();
	if( m_hStopEvent )
		::CloseHandle(m_hStopEvent);
	m_hStopEvent = NULL;
}

BOOL CMemServer::Start(CALLBACK_PROC pfnCmdProc, void* pParam, int iThreadPriority)
{
	if( pfnCmdProc == NULL || pParam == NULL ){
		return FALSE;
	}
	if( m_hThread != NULL ){
		return FALSE;
	}
	m_pCmdProc = pfnCmdProc;
	m_pParam = pParam;
	m_iThreadPriority = iThreadPriority;

	//ڑҋ@pCxg
	wstring eventConnectName;
	Format( eventConnectName, L"Global\\%sEventConnect", m_serverName.c_str() );
	m_hEventConnect = _CreateEvent(FALSE, FALSE, eventConnectName.c_str());

	wstring eventCallName;
	Format( eventCallName, L"Global\\%sEventCall", m_serverName.c_str() );
	m_hEventCall = _CreateEvent(FALSE, FALSE, eventCallName.c_str());

	wstring eventReturnName;
	Format( eventReturnName, L"Global\\%sEventReturn", m_serverName.c_str() );
	m_hEventReturn = _CreateEvent(FALSE, FALSE, eventReturnName.c_str());

	m_hMapping = _CreateFileMapping( INVALID_HANDLE_VALUE, PAGE_READWRITE, 0, 512*1024, NULL );
	
	m_buf = (BYTE *)MapViewOfFile( m_hMapping, FILE_MAP_ALL_ACCESS, 0, 0, 0);

	//CxgIuWFNg̍쐬ɎsꍇXbhJnȂ
	if( m_buf == NULL ) return FALSE;

	ResetEvent(m_hStopEvent);
	m_hThread = (HANDLE)_beginthreadex(NULL, 0, ServerThread, (LPVOID)this, CREATE_SUSPENDED, NULL);
	ResumeThread(m_hThread);

	return TRUE;
}

void CMemServer::Stop()
{
	if( m_hThread != NULL ){
		::SetEvent(m_hStopEvent);
		// XbhI҂
		if ( ::WaitForSingleObject(m_hThread, 2000) == WAIT_TIMEOUT ){
			::TerminateThread(m_hThread, 0xffffffff);
		}
		CloseHandle(m_hThread);
		m_hThread = NULL;
	}

	if( m_buf ) {
		UnmapViewOfFile( m_buf );
		m_buf = NULL;
	}
	if( m_hMapping ) {
		::CloseHandle(m_hMapping);
		m_hMapping = NULL;
	}
	if( m_hEventConnect ) {
		::CloseHandle(m_hEventConnect);
		m_hEventConnect = NULL;
	}
	if( m_hEventCall ) {
		::CloseHandle(m_hEventCall);
		m_hEventCall = NULL;
	}
	if( m_hEventReturn ) {
		::CloseHandle(m_hEventReturn);
		m_hEventReturn = NULL;
	}
}

HANDLE CMemServer::DuplicateFileMappingHandle( DWORD processID )
{
	HANDLE hProcess;
	HANDLE hDuplicate;
	hProcess = OpenProcess( PROCESS_ALL_ACCESS, FALSE, processID );
	DuplicateHandle( GetCurrentProcess(), m_hMapping, hProcess,  &hDuplicate, 
		FILE_MAP_ALL_ACCESS, FALSE, 0 );
	CloseHandle( hProcess );
	return hDuplicate;
}

UINT WINAPI CMemServer::ServerThread(LPVOID pParam)
{
	CMemServer* pSys = (CMemServer*)pParam;
	return pSys->ServerThread();
}

UINT CMemServer::ServerThread()
{

	HANDLE hCurThread = GetCurrentThread();
	SetThreadPriority(hCurThread, m_iThreadPriority);

	HANDLE hEventArray[2] = { m_hStopEvent, m_hEventCall };
	
	SetEvent(m_hEventConnect);
	while(1){
		DWORD dwRes = WaitForMultipleObjects(2, hEventArray, FALSE, INFINITE);
		if( dwRes == WAIT_OBJECT_0 ){
			//STOP
			break;
		}else if( dwRes == WAIT_OBJECT_0+1 ) {
			m_pCmdProc(m_pParam, m_buf );
			SetEvent( m_hEventReturn );			
		}
	}
	return 0;
}
