#pragma once

#include "StringUtil.h"
#include "PT1OutsideCtrlCmdDef.h"

typedef int (CALLBACK *CMD_CALLBACK_PROC)(void* pParam, CMD_STREAM* pCmdParam, CMD_STREAM* pResParam);

class CPipeServer
{
public:
	CPipeServer(void);
	~CPipeServer(void);

	BOOL StartServer(LPCWSTR lpszEventConnectName, LPCWSTR lpwszPipeName, CMD_CALLBACK_PROC pfnCmdProc, void* pParam, int iThreadPriority = THREAD_PRIORITY_NORMAL);
	void StopServer();

	void Lock();
	void Unlock();

protected:
	CMD_CALLBACK_PROC m_pCmdProc;
	void* m_pParam;
	wstring m_strEventConnectName;
	wstring m_strPipeName;

	int m_iThreadPriority;

	HANDLE m_hStopEvent;
	HANDLE m_hThread;

	HANDLE m_hPipe;
	//HANDLE m_hEventCmdWait;
	HANDLE m_hEventConnect;
	CRITICAL_SECTION m_cs;
	bool m_bStop;
protected:
	static UINT WINAPI ServerThread(LPVOID pParam);
	UINT WINAPI ServerThread();

};

